#include "DLTestManager.h"
#include "DLTest.h"
#include "DLScriptIDBatchTest.h"
#include "DLVersions.h"
#include <iostream>

using namespace std;

/**
 * \brief The main function of the driver application that runs
 * script identification on a list of user specified document images
 */
int main(int argc, char *argv[])
{
	cout << "University of Maryland Script and Language Identification Module" << endl;
	cout << "DOCLIB version " << DL_VERSION << endl;

	// add your new test below
	DLTestManager mgr(argc, argv);

	DLScriptIDBatchTest scriptIDDetectTest("Script identification ...", argc, argv);
	mgr.addTestCase(&scriptIDDetectTest);
	mgr.go();

	// end of your test case
}
