#ifndef UTILS_H
#define UTILS_H
#include "JScript.h"

/**
 * Utils class contain utility functions for Jargon
 */
/// Utils class contain utility functions for Jargon
class Utils
{
   public:
   /// Utils constructor   
   Utils(void);
   /// Utils destructor
   ~Utils(void);

   /**
    * Harmming
    * /param img1 
    * /param img2
    * /return int
    */
   static int hamming(char *img1,  char *img2 );

   /**
    * save_script_data is a function to save out to
    * training data to a text file in a defined format
    * /param file_path file name to be saved
    * /param language pointer pointing to the language list
    * /param first_cluster pointer pointing to the first cluster
    * /param height height of the component
    * /param width width of the component
    */
   static void save_script_data(char *file_path, 
                                language_profile *language, 
                                jcluster *first_cluster,int height, int width);
};


#endif
