#include <cstdio>
#include <iostream>
#include <fstream>
#include <fstream>
#include <string>
#include <cstring>
#include <string>
#include <vector>
#include <polyClass.h>
#include <polyMatchClass.h>
#include <math.h>
//extern          "C"
//{
//#include <math.h>
//}
/* #define tr_s(tr,i) (tr->leg[i % tr->n].s + i/tr->n) #define tr_smt(tr,i,t)
 * (tr->leg[i% tr-n].s -t) + i/tr->n) #define tr_theta(tr,i) (tr->leg[i %
 * tr->n].theta + i / tr->n * 2 * M_PI) #define sqr(x) (x * x) #define
 * pmin(x,y) (x < y ? x : y) */
/******************************************************/
polyMatchClass::polyMatchClass()
{

  ;
}
/******************************************************/
/* double polyMatchClass::matchPoly(pointLocation *poly1, pointLocation
 * *poly2,int cnt) */
double          polyMatchClass::
matchPoly(TURN_REP g, TURN_REP f, int cnt)
{
  int             update_p, precise_p, n_repeats;
//  TURN_REP_REC    trg1, trg2;
  EVENT_REC       e;
  double          ht0, slope, alpha, theta_star, metric2, metric, ht0_err,
                  slope_err;

  precise_p = 0;
  update_p = 1;
  n_repeats = 1;

  /* switches to control algorith - need to relook at this while(--argc) {
   * ++argv; if (argv[0][0] == '-' && argv[0][1] != '\0') switch(argv[0][1])
   * { case 'p': precise_p = 1; break; case 'n': update_p = 0; break; case
   * 'r': if (sscanf(&argv[0][2], "%d", &i) == 1) n_repeats = i; break;
   * default: fprintf(stderr, "sim: unknown option\n"); exit(1); } } */
  /* poly_to_turn_rep(poly1,cnt,&trg1); poly_to_turn_rep(poly2,cnt,&trg2); g
   * = &trg1; f = &trg2; */
  init_vals(f, g, &ht0, &slope, &alpha);
  init_events(f, g);
  metric2 = h_t0min(f, g,
		    ht0, slope, alpha,
		    update_p ? reinit_interval(f, g) : 0,
		    &theta_star, &e, &ht0_err, &slope_err);

  /* Fixups: The value of metric2 can be a tiny negative number for an exact
   * match.  Call it 0. Theta_star can be over 360 or under -360 because we
   * handle t=0 events at t=1. Normalize to [-PI,PI). */
  metric = metric2 > 0 ? sqrt(metric2) : 0;
  /* printf(precise_p ? "%.18lg %.18lg %d %d %lg %lg" : "%lg %lg %d %d %lg
   * %lg", metric, turn(theta_star, 0)*180/M_PI, tr_i(f, e.fi), tr_i(g,
   * e.gi), ht0_err, slope_err);
   * 
   * printf("\n"); */
  _score = metric;
  return (_score);


}
/****************************************************** 
double          polyMatchClass::
tr_s_old(TURN_REP tr, int i)
{
  return (tr->leg[i % tr->n].s + i / tr->n);
}
*/
/******************************************************

double          polyMatchClass::
tr_smt_old(TURN_REP tr, int i, double t)
{
  return ((tr->leg[i % tr->n].s - t) + i / tr->n);
}
*/

/******************************************************
double          polyMatchClass::
tr_theta_old(TURN_REP tr, int i)
{
  return (tr->leg[i % tr->n].theta + i / tr->n * 2 * M_PI);
}
*/

/* Square a double. */
/*****************************************************
double          polyMatchClass::
sqr_old(double x)
{
  return (x * x);
}
*/

/* Compute min of two ints. */
/*****************************************************
int             polyMatchClass::
pmin_old(int x, int y)
{
  return (x < y ? x : y);
}
*/

/* Compute floor(log_base2(x)) */
/******************************************************/
int             polyMatchClass::
ilog2(int x)
{
  int             l;

  l = -1;
  while (x != 0)
  {
    x >>= 1;
    ++l;
  }
  return (l);
}

/* Return angle a, adjusted by +-2kPI so that it is within [base-PI,
 * base+PI). */
/******************************************************/
double          polyMatchClass::
turn(double a, double base)
{
  while (a - base < -M_PI)
    a += 2 * M_PI;
  while (a - base >= M_PI)
    a -= 2 * M_PI;
  return (a);
}


/******************************************************/
/* Convert a polygon to a turning rep.  This computes the absolute angle of
 * each leg wrt the x-axis, then adjusts this to within PI of the last leg to
 * form the turning angle.  Finally, the total length of all legs is used to
 * compute the cumulative normalized arc length of each discontinuity, s. */
void            polyMatchClass::
poly_to_turn_rep(pointLocation * vertices, int polySideCount, TURN_REP t)
{
  int             n, i0, i1;
  double          dx, dy, theta1, theta0, total_len, len;

  n = t->n = polySideCount;
  total_len = 0;
  for (theta0 = 0, i0 = 0; i0 < n; theta0 = theta1, ++i0)
  {
    /* Look one vertex ahead of i0 to compute the leg. */
    i1 = (i0 + 1) % n;

    dx = (double) vertices[i1].x - (double) vertices[i0].x;
    dy = (double) vertices[i1].y - (double) vertices[i0].y;
    t->leg[i0].theta = theta1 = turn(atan2(dy, dx), theta0);
    total_len += t->leg[i0].len = sqrt(dx * dx + dy * dy);
  }
  t->total_len = total_len;
  for (len = 0, i0 = 0; i0 < n; ++i0)
  {
    t->leg[i0].s = len / total_len;
    len += t->leg[i0].len;
  }
}

/******************************************************/
/* Fill in a turn rep with a rotated version of an original.  Normalized arc
 * lengths start at 0 in the new representation. */
void            polyMatchClass::
rotate_turn_rep(TURN_REP t, int to, TURN_REP r)
{
  int             ti, ri, n;
  double          len, total_len;
  LEG            *l;

  n = r->n = t->n;
  total_len = r->total_len = t->total_len;
  for (ti = to, ri = 0; ri < n; ++ti, ++ri)
  {
    l = &r->leg[ri];
    l->theta = tr_theta(t, ti);
    l->len = tr_len(t, ti);
    l->s = tr_s(t, ti);
  }
  for (len = 0, ri = 0; ri < n; ++ri)
  {
    r->leg[ri].s = len / total_len;
    len += r->leg[ri].len;
  }
}

/******************************************************/
/* In one O(m + n) pass over the turning reps of the polygons to be matched,
 * this computes all the terms needed to incrementally compute the metric.
 * See the paper. */
void            polyMatchClass::
init_vals(TURN_REP f, TURN_REP g, double *ht0_rtn, double *slope_rtn, double *a_rtn)
{
  int             i, n;		/* loop params */
  int             fi, gi;	/* disconts that bound current strip */
  double          ht0, slope;	/* per paper */
  double          a;		/* alpha in the paper */
  double          last_s;	/* s at left edge of current strip */
  double          ds;		/* width of strip */
  double          dtheta;	/* height of strip */
		double test1,test2;

  last_s = 0;
  /* First strip is between 0 and the earliest of 1'th f and g disconts. */
  gi = 1;
  fi = 1;
  /* Zero accumulators and compute initial slope. */
  ht0 = a = 0;
  slope = (tr_s(g, 1) < tr_s(f, 1)) ? 0 : -sqr(tr_theta(g, 0) - tr_theta(f, 0));
  /* Count all the strips */

/*  for (i = 0, n = tr_n(f) + tr_n(g) - 1; i < n; ++i) */
  for (i = 0, n = 7; i < n; ++i)
  {
    /* Compute height of current strip. */
    dtheta = tr_theta(g, gi - 1) - tr_theta(f, fi - 1);
    /* Determine flavor of discontinuity on right. */

    if (tr_s(f, fi) <= tr_s(g, gi))
    {
      /* It's f. Compute width of current strip, then bump area accumulators. */
      ds = tr_s(f, fi) - last_s;
      a += ds * dtheta;
      ht0 += ds * dtheta * dtheta;

      /* Determine flavor of next strip.  We know it's ff or fg.  In latter
       * case, bump accumulator.  Note we've skipped the first strip.  It's
       * added as the "next" of the last strip. */
						test1 = tr_s(f, fi + 1);
						test2 = tr_s(g, gi);
      if (tr_s(f, fi + 1) > tr_s(g, gi))
	slope += sqr(tr_theta(f, fi) - tr_theta(g, gi - 1));
      /* Go to next f discontinuity. */
      last_s = tr_s(f, fi);
						fi++;
    } else
    {
      /* Else it's g ... */
      ds = tr_s(g, gi) - last_s;
      a += ds * dtheta;
      ht0 += ds * dtheta * dtheta;
      /* ... and next strip is gg or gf, and again we're interested in the
       * latter case. */
      if (tr_s(g, gi + 1) >= tr_s(f, fi))
	slope -= sqr(tr_theta(g, gi) - tr_theta(f, fi - 1));
      /* Go to next g discontinuity. */
      last_s = tr_s(g, gi);
						gi++;
    }
  }
  /* Set up all return values. */
  *ht0_rtn = ht0;
  *slope_rtn = slope;
  *a_rtn = a;
}

/******************************************************/
/* Recompute ht0 and slope for the current event. Renormalize the turning
 * reps so that the event discontinuities are first in each.  This keeps all
 * s values within [0,1) while recomputing so that all are represented with
 * the same precision. If we check that no other events are pending within
 * machine epsilon of t for (fi,gi) before calling this, numerical stability
 * is guaranteed (unlike the first two ways I tried). */
void            polyMatchClass::
reinit_vals(TURN_REP f, TURN_REP g, int fi, int gi, double *ht0_rtn, double *slope_rtn)
{
  double          a;
  TURN_REP_REC    fr, gr;

  rotate_turn_rep(f, fi, &fr);
  rotate_turn_rep(g, gi, &gr);
  init_vals(&fr, &gr, ht0_rtn, slope_rtn, &a);
}

/* Compute number of events between successive reinits that will not blow the
 * asymptotice complexity bound. */
int             polyMatchClass::
reinit_interval(TURN_REP f, TURN_REP g)
{
  return tr_n(f) * tr_n(g) / (pmin(tr_n(f), tr_n(g)) * ilog2(tr_n(g)));
}

/******************************************************/
/* Following are routines to maintian the event heap.  This is initialized
 * with one event per g discontinuity, namely, the one due to the f
 * discontinuity closest to the right. The sort key is the "f shift"
 * parameter t.  As the algorithm runs, it draws an event (of pmin t) from
 * the heap, handles it, then inserts the event due to the *next* f
 * discontinuity associated with the same g discontinuity (unless this event
 * would have t>1).
 * 
 * The heap insert and delete are minor modifications of pseudo-code from
 * Horowitz and Sahni, Computer Algorithms. */
static HEAP     event;
static int      n_events = 0;

/* Insert a new event in the heap. */
void            polyMatchClass::
add_event(TURN_REP f, TURN_REP g, int fi, int gi)
{
  double          t;
  int             i, j;
  EVENT           e;

  if ((t = tr_s(f, fi) - tr_s(g, gi)) > 1)
    return;
  j = ++n_events;
  i = n_events / 2;
  while (i > 0 && event[i].t > t)
  {
    event[j] = event[i];
    j = i;
    i = i / 2;
  }
  e = &event[j];
  e->t = t;
  e->fi = fi;
  e->gi = gi;
}

/******************************************************/
/* Remove the event of min t from the heap and return it. */
EVENT_REC       polyMatchClass::
next_event(void)
{
  int             i;
  EVENT_REC       next = event[1];	/* remember event to return */
  EVENT_REC       e = event[n_events];	/* new root (before adjust) */

  --n_events;
  i = 2;
  while (i <= n_events)
  {
    if (i < n_events && event[i].t > event[i + 1].t)
      ++i;
    if (e.t <= event[i].t)
      break;
    else
    {
      event[i / 2] = event[i];
      i *= 2;
    }
  }
  event[i / 2] = e;
  return (next);
}

/******************************************************/
/* Peek at the next t to come off the heap without removing the element. */
#define next_t()    event[1].t

/* Scan the turning reps to create the initial events in the heap as
 * described above. */
void            polyMatchClass::
init_events(TURN_REP f, TURN_REP g)
{
  int             fi, gi;

  n_events = 0;
  /* Cycle through all g discontinuities, including the one at s = 1.  This
   * takes care of s = 0. */
  for (fi = gi = 1; gi <= tr_n(g); ++gi)
  {
    /* Look for the first f discontinuity to the right of this g
     * discontinuity. */
    while (tr_s(f, fi) <= tr_s(g, gi))
				{
/*
						printf("old tr_s(f,fi): %f   new trs(f,fi): %f\n",
							tr_s_old(f, fi), tr_s(f, fi));
*/
						/*
						printf("gi: %d fi: %d  tr_s(f, fi): %f   tr_s(g, gi): %f \n",
							gi,fi,tr_s(f, fi), tr_s(g, gi)); */
      ++fi;
				}
    add_event(f, g, fi, gi);
  }
}

/******************************************************/
/* The heart of the algorithm:  Compute the minimum value of the integral
 * term of the metric by considering all critical events. This also returns
 * the theta* and event associated with the minimum. */
double          polyMatchClass::
h_t0min(TURN_REP f, TURN_REP g,
	double hc0, double slope, double alpha, int d_update,
	double *theta_star_rtn, EVENT e_rtn,
	double *hc0_err_rtn, double *slope_err_rtn)
{
  int             left_to_update;	/* # disconts left until update */
  double          metric2, min_metric2;	/* d^2 and d^2_min thus far */
  double          theta_star, min_theta_star;	/* theta* and theta*_min thus
						 * far */
  double          last_t;	/* t of last iteration */
  double          hc0_err, slope_err;	/* error mags discovered on update */
  EVENT_REC       e;		/* current event */
  EVENT_REC       min_e;	/* event of d^2_min thus far */

  static EVENT_REC init_min_e = {0, 0, 0};	/* implicit first event */

  /* At t = 0, theta_star is just alpha, and the min metric2 seen so far is
   * hc0 - min_theta_star^2. Also, no error has been seen. */
  min_theta_star = alpha;
  min_metric2 = hc0 - min_theta_star * min_theta_star;
  min_e = init_min_e;
  last_t = hc0_err = slope_err = 0;
  /* Compute successive hc_i0's by incremental update at critical events as
   * described in the paper. */
  left_to_update = d_update;
  while (n_events > 0)
  {
    e = next_event();
    hc0 += (e.t - last_t) * slope;
    theta_star = alpha - 2 * M_PI * e.t;
    metric2 = hc0 - theta_star * theta_star;
    if (metric2 < min_metric2)
    {
      min_metric2 = metric2;
      min_theta_star = theta_star;
      min_e = e;
    }
    /* Update slope, last t, and put next event for this g discontinuity in
     * the heap. */
    slope += 2 * (tr_theta(f, e.fi - 1) - tr_theta(f, e.fi))
      * (tr_theta(g, e.gi - 1) - tr_theta(g, e.gi));
    last_t = e.t;
    add_event(f, g, e.fi + 1, e.gi);
    /* Re-establish hc0 and slope now and then to reduce numerical error.  If
     * d_update is 0, do nothing. Note we don't update if an event is close,
     * as this causes numerical ambiguity.  The test number could be much
     * smaller, but why tempt Murphey?  We force an update on last event so
     * there's always at least one. */
    if (d_update &&
	(n_events == 0 ||
    --left_to_update <= 0 && e.t - last_t > 0.001 && next_t() - e.t > 0.001))
    {

      double          rihc0, rislope, dhc0, dslope;

      reinit_vals(f, g, e.fi, e.gi, &rihc0, &rislope);
      dhc0 = hc0 - rihc0;
      dslope = slope - rislope;
      if (fabs(dhc0) > fabs(hc0_err))
	hc0_err = dhc0;
      if (fabs(dslope) > fabs(slope_err))
	slope_err = dslope;
      hc0 = rihc0;
      slope = rislope;
      left_to_update = d_update;
    }
  }
  /* Set up return values. */
  *theta_star_rtn = min_theta_star;
  *e_rtn = min_e;
  *hc0_err_rtn = hc0_err;
  *slope_err_rtn = slope_err;
  return (min_metric2);
}
