#include "JHamming.h"


void JHamming::CreateHammingLUT32(int* hamming_lookup,int bits_needed) {
   int i;

   for (i = 0; i < bits_needed; i++) {
      hamming_lookup[i] = 0;
      /* first 8 bytes */
      if (i & 0x01) hamming_lookup[i]++;
      if (i & 0x02) hamming_lookup[i]++;
      if (i & 0x04) hamming_lookup[i]++;
      if (i & 0x08) hamming_lookup[i]++;
      if (i & 0x10) hamming_lookup[i]++;
      if (i & 0x20) hamming_lookup[i]++;
      if (i & 0x40) hamming_lookup[i]++;
      if (i & 0x80) hamming_lookup[i]++;

      if (i & 0x0100) hamming_lookup[i]++;
      if (i & 0x0200) hamming_lookup[i]++;
      if (i & 0x0400) hamming_lookup[i]++;
      if (i & 0x0800) hamming_lookup[i]++;
      if (i & 0x1000) hamming_lookup[i]++;
      if (i & 0x2000) hamming_lookup[i]++;
      if (i & 0x4000) hamming_lookup[i]++;
      if (i & 0x8000) hamming_lookup[i]++;
   }


}
/* Returns number of pixel agreements between two image pixmaps */

int JHamming::bytewise_hamming(char *img1,  char *img2 ,int size)
{
   int i ;
   int score = 0;
   int j;

   for (i = 0; i < size; i++)
   {
      j = img1[i];
      j = img2[i];

      if (img1[i] == img2[i])
         score = score+1;
   } /* done for each row */

   return (score);
}
