#include "JargonUtils.h"
#include <cstdlib>
#include <stdio.h>
#include "JScript.h"
#include "JHamming.h"

#include "DLLogger.h"

#include <cmath>

using namespace std;

JargonUtils::JargonUtils(void)
{
}

JargonUtils::~JargonUtils(void)
{
}

void JargonUtils::ConvertUSCInt(unsigned int* ui, unsigned char* image) {
   int i;
  
   /* need to loop through 12 times and then add the last 16 bits */
   for (i =0; i < 12; i++) {
      /* fix this: loop through and put 4 bytes in 1 */
      ui[i] =   (int)image[4*i] << 24;
      ui[i] += ((int)image[4*i+1] << 16);
      ui[i] += ((int)image[4*i+2] << 8);
      ui[i] +=  (int)image[4*i+3];
   };
  
   /* put the last 2 on */
   ui[12] = (image[48]<<8) ^ image[49];
};



//void JargonUtils::ReadScriptData(char *language_list_path, language_profile **language_array, int *language_count, int scaled_height, int scaled_width, float *threshold,
//	int **gray_values)
//{
//int max_gray;
//int char_count;
//FILE *language_fp;
//FILE *script_data_fp;
//int result;
//char language_string[MAX_FILENAME_LEN+1];
//char script_data_string[MAX_FILENAME_LEN+1];
//language_profile *language_ptr;
//int bits_needed;
//int bytes_needed;
//unsigned char *byte_array;
//int *int_array;
//int i;
//int j;
//int k;
//jcluster *cluster_ptr;
//unsigned char *data_ptr;
//int *test_array;
//int h_half;
//int w_half;
//int gray_index = 0;
//int *gray_ptr;
//
///* float values[13] = {.9,.45,.7,.35,.425,.3,.7,.15,.7,.125,.2,.67,.74}; */
//float values[13] = {.65, .65, .65, .65, .4, .65, .65, .65, .55, .15, .65, .65, .65}; 
//int iCounter;
//
///* open file and compute number of languages */
//
//language_fp = fopen(language_list_path,"r");
//if (language_fp == NULL)
//{
//	printf("Could not open list of scripts: %s \n", language_list_path);
//	exit(-1);
//}
//
//result = fscanf(language_fp,"%s %s",language_string, script_data_string);
//*language_count = 0;
//while (result > 0)
//{
//	*language_count = *language_count+1;
//	result = fscanf(language_fp,"%s %s",language_string, script_data_string);
//
//}
//
//
///* allocate room for language array */
//
//*language_array = (language_profile *) calloc (*language_count,
//	sizeof(language_profile));
//language_ptr = *language_array;
//
///* if needed allocate room to store the gray scale values.  Need
//to monitor to make sure we don't run out of room */
//
//
//bits_needed = scaled_height*scaled_width;
//if (gray_values != NULL)
//{
//		*gray_values = (int *) calloc(*language_count*
//			2000*bits_needed,
//			sizeof(int));
//		max_gray = *language_count*2000*bits_needed;
//		gray_ptr = *gray_values;
//}
//
//fseek (language_fp, 0, 0);
//
//
///* allocate slightly more space then needed for the byte
//array to uninitialized memory read errors within the compress
//to bit routine */
//
//bytes_needed = ceil((double)bits_needed/8.0);
//int_array = (int *) calloc(1,bits_needed*sizeof(int));
//test_array = (int *) int_array;
//result = fscanf(language_fp,"%s %s",language_string, script_data_string);
//iCounter = 0;
//while (result > 0)
//{
//	script_data_fp = fopen(script_data_string,"r");
//	if (script_data_fp == NULL)
//	{
//		printf("could not open script data for script: %s",
//			language_string);
//		exit(-1);
//	}
//
//	/* read language data */
//
//	fseek(script_data_fp,0,SEEK_SET);
//        result = fscanf(script_data_fp,"%s %n",
//                language_ptr-> identification,&char_count);
//		
//        result = fscanf(script_data_fp,"%d  %n",
//                &language_ptr-> cluster_count,&char_count);
//
//	 result = fscanf(script_data_fp,"%d %d %d %d %d ",
//                &language_ptr-> filtered_cluster_count,
//                &language_ptr-> file_count,
//                &language_ptr-> hamming,
//                &language_ptr-> symbol_count,
//                &language_ptr-> small_cluster_threshold);
//	result = fscanf(script_data_fp, "%d %d %d %d %d %d ",
//                &language_ptr-> min_size,
//                &language_ptr-> max_height,
//                &language_ptr-> max_width,
//                &language_ptr-> total_symbol_count,
//                &language_ptr-> correctly_matched,
//                &language_ptr-> incorrectly_matched);
//        fscanf(script_data_fp,"%u %u %f ",
//                &language_ptr->  hamming_sum,
//                &language_ptr->  best_hamming,
//                &language_ptr-> matched_sum);
//
//
//
//	/* allocate room for cluster data structure and a
//	array for the centroid */
//
//	language_ptr ->first_cluster = (jcluster *) 
//		calloc(language_ptr->cluster_count,
//		sizeof(jcluster));
//	language_ptr ->cluster_data= (char *) 
//		calloc(language_ptr->cluster_count*bytes_needed,
//		sizeof(char));
//
//
//	data_ptr = (unsigned char *) language_ptr->cluster_data;
//	cluster_ptr = (jcluster *) language_ptr->first_cluster;
//
//	for (i=0; i< language_ptr->cluster_count; i++)
//	{
//
//		/* read cluster info */
//
//		fscanf(script_data_fp,"%d %d %d %f %u %d %d ",
//			&cluster_ptr-> count,
//			&cluster_ptr-> correct_matches,
//			&cluster_ptr-> incorrect_matches,
//			&cluster_ptr-> reliability,
//			&cluster_ptr-> similar_symbol_count,
//			&cluster_ptr-> matches_per_image,
//			&cluster_ptr-> on_pixels);
//
//		cluster_ptr->on_pixels = 0;
//
//		for (j=0;j< bits_needed;j++)
//		{
//			fscanf(script_data_fp,"%d ",&int_array[j]);
//			if (gray_values != NULL)
//			{
//				if (gray_index >= max_gray)
//				{
//					*gray_values = (int *)realloc(*gray_values,
//						 max_gray*2);
//						max_gray = 2*max_gray;
//						gray_ptr = *gray_values;
//				}
//				gray_ptr[gray_index] = int_array[j];
//				gray_index++;
//			}
//		}
//
///*****
//
//		/* read and discard the first image 
//
//		fread(byte_array, bits_needed, 1, script_data_fp);
//
//		/* read centroid 
//
//		fread(int_array, sizeof(int)*bits_needed, 1, script_data_fp);
//
//*/
//
//		/* threshold at 125 and store in byte array */
//
//		byte_array = (unsigned char *) calloc(1,bits_needed);
//		h_half = scaled_height/2;
//		w_half = scaled_width/2;
//		for (j=0;j< scaled_height;j++)
//		{
//			for (k = 0;k< scaled_width;k++)
//			{			
//			  /* 			  if (test_array[j*scaled_height + k] > (int) ((float) cluster_ptr->count * (*threshold))) 			    { */
//			  if (test_array[j*scaled_height + k] > (int) ((float) cluster_ptr->count * values[iCounter])) {
//			  
//				byte_array[j*scaled_height + k] = 0xff;
//				cluster_ptr->on_pixels =  cluster_ptr->on_pixels+1;
//				/* compute density for quadrants */
//
//				if ((j < h_half) && (k < w_half))
//				cluster_ptr->densities[0] = 
//					 cluster_ptr->densities[0] +1;
//				else
//				if ((j < h_half) && (k >= w_half))
//				cluster_ptr->densities[1] = 
//					 cluster_ptr->densities[1] +1;
//				else
//				if ((j >= h_half) && (k < w_half))
//				cluster_ptr->densities[2] = 
//					 cluster_ptr->densities[2] +1;
//				else
//				cluster_ptr->densities[3] = 
//					 cluster_ptr->densities[3] +1;
//
//			}
//			}
//		}
//
//		/* store the bit data immediately after cluster
//			structure */
//
//        JMorphology::compress_to_bit(byte_array, 
//			data_ptr,
//			bits_needed, bytes_needed);
//		
//		free(byte_array);
//		/* move pointer to next cluster */
//		
//		cluster_ptr++;
//		data_ptr = data_ptr + bytes_needed;
//	}
//	language_ptr++;
//	iCounter++;
//	fclose (script_data_fp);
//	result = fscanf(language_fp,"%s %s",language_string, script_data_string);
//}
///* already freed */
///* free(byte_array); */
//free(int_array);
//fclose (language_fp);
//}
//
