#ifndef __polyClass_H
#define __polyClass_H


#define _USE_MATH_DEFINES 
using namespace std;

enum crossingType { non_object=-3,intersect, coincident,  parallel,no_intersection };

struct pointLocation
{
   int x;
   int y;

   pointLocation(){}
   pointLocation(int xx, int yy) { x= xx; y = yy;}
   const pointLocation & operator = (pointLocation b)
   {
      x = b.x; y = b.y; return *this;
   }
   pointLocation & operator + (pointLocation b)
   { x += b.x; y+=b.y; return *this;}

 
};


class polyClass {

   public:
   polyClass();	
   polyClass(vector<pointLocation> pts);
   ~polyClass();

   int		get_upper_area_delta();
   int		get_lower_area_delta();
   int		linesIntersect();
   float   getArea();
   void	orderVertices();

   private:
   pointLocation*	_polyStruct;
   int				_polygonSideCount;
   int				tmp;

};

#endif

